#
# skeletonTestCase Skeleton
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.DataGridField.tests import datagridTestCase


class testInstallation(datagridTestCase.datagridTestCase):

    def afterSetUp(self):
        pass

    def testPortalTypes(self):
        types = self.portal.portal_types.objectIds()
        self.failUnless('DataGridDemoType' in types)

    def testPortalSkins(self):
        skins = self.portal.portal_skins.objectIds()
        self.failUnless('DataGridWidget' in skins)

    def testAddingDemo(self):
        self.folder.invokeFactory('DataGridDemoType','foo')
        self.failUnless('foo' in self.folder.objectIds())
    
    def testGettingField(self):
        self.folder.invokeFactory('DataGridDemoType','foo')
        self.failIf(self.folder.foo.getDemoField())    

    def testSettingField(self):
        self.folder.invokeFactory('DataGridDemoType','foo')
        vals = [{'column1':'joe'}]
        self.folder.foo.setDemoField(vals)
        self.assertEqual(len(self.folder.foo.getDemoField()),1)
        self.assertEqual(self.folder.foo.getDemoField()[0]['column1'],vals[0]['column1'])    

    def testSettingEmptyRows(self):
        self.folder.invokeFactory('DataGridDemoType','foo')
        vals = [{'column1':''}]
        self.folder.foo.setDemoField(vals)
        self.assertEqual(self.folder.foo.getDemoField(),[])    
        self.failIf(self.folder.foo.getDemoField())
        
    def testRenderingDoesNotFail(self):
        self.folder.invokeFactory('DataGridDemoType','foo')
        self.failUnless(self.folder.foo())      
        
         
        
    def testSomething(self):
        # Test something
        self.assertEqual(1+1, 2)


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(testInstallation))
    return suite

if __name__ == '__main__':
    framework()
