# File: SCAuditorium.py
"""\
unknown

"""
# Copyright (c) 2005 by SureCase.org
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''SureCase.org <info@surecase.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *




from Products.SCAuditorium.config import *
##code-section module-header #fill in your manual code here
try:
    # Multilingual support
    from Products.LinguaPlone.public import *
except ImportError:
    # No multilingual support
    from Products.Archetypes.public import *

from Products.CMFCore.utils import getToolByName
from Products.DataGridField import DataGridField, DataGridWidget
##/code-section module-header

schema= Schema((
    StringField('title',
        widget=StringWidget(
            label="Title",
            description="Enter title for this Auditorium.",
            label_msgid='SCAuditorium_label_title',
            description_msgid='SCAuditorium_help_title',
            i18n_domain='SCAuditorium',
        ),
        required=True,
        searchable=True,
    ),
    
    TextField('description',
        widget=TextAreaWidget(
            label="Description",
            description="Enter short description for this Auditorium.",
            label_msgid='SCAuditorium_label_description',
            description_msgid='SCAuditorium_help_description',
            i18n_domain='SCAuditorium',
        ),
        required=False,
        searchable=True,
    ),
    
    ImageField('auditorium_icon',
        widget=ImageWidget(
            label="Auditorium icon",
            description="Upload image for auditorim title icon.",
            label_msgid='SCAuditorium_label_auditorium_icon',
            description_msgid='SCAuditorium_help_auditorium_icon',
            i18n_domain='SCAuditorium',
        ),
        languageIndependent=False,
        storage=AttributeStorage(),
        original_size=(64,64),
        sizes={'icon':(16, 16), 'thumb':(64,64)},
    ),
    
    StringField('portraits_size',
        default=VOC_PORTRAIT_SIZES[1],
        widget=SelectionWidget(
            label="Portraits size",
            description="Select which size of users's portraits should be used when displaying Posts.",
            label_msgid='SCAuditorium_label_portraits_size',
            description_msgid='SCAuditorium_help_portraits_size',
            i18n_domain='SCAuditorium',
        ),
        languageIndependent=True,
        vocabulary=VOC_PORTRAIT_SIZES,
        required=True,
    ),
    
    StringField('date_formats',
        default=1,
        widget=SelectionWidget(
            label="Date formats",
            description="Select which format will be used to displaying dates of post's creation.",
            label_msgid='SCAuditorium_label_date_formats',
            description_msgid='SCAuditorium_help_date_formats',
            i18n_domain='SCAuditorium',
        ),
        languageIndependent=True,
        accessor="dateFormats",
        vocabulary=VOC_DATE_FORMATS,
    ),
    
    IntegerField('def_page_size',
        default=20,
        widget=IntegerWidget(
            label="Default page size",
            description="Enter integer value for default posts count on one page of Auditorium ( value can be temporarelly changed by user during Auditorium browsing).",
            label_msgid='SCAuditorium_label_def_page_size',
            description_msgid='SCAuditorium_help_def_page_size',
            i18n_domain='SCAuditorium',
        ),
        languageIndependent=True,
        accessor="getPageSize",
    ),
    
    IntegerField('max_item_length',
        default=256,
        widget=IntegerWidget(
            label="Max. Post's body length",
            description="Enter integer value for maximal length of Post's body.",
            label_msgid='SCAuditorium_label_max_item_length',
            description_msgid='SCAuditorium_help_max_item_length',
            i18n_domain='SCAuditorium',
        ),
        languageIndependent=True,
        accessor="getLimitedTextMaxlength",
    ),
    
    BooleanField('moderated',
        widget=BooleanWidget(
            label="Moderated Auditorium",
            description="Check this option to make Auditorium moderated.",
            label_msgid='SCAuditorium_label_moderated',
            description_msgid='SCAuditorium_help_moderated',
            i18n_domain='SCAuditorium',
        ),
        languageIndependent=True,
        accessor="isModerated",
    ),
    
    LinesField('allowed_html_tags',
        default=DEFAULT_ALLOWED_HTML_TAGS,
        widget=LinesWidget(
            label="Allowed HTML tags",
            description="Enter list of HTML tags which can be used in Post's body. Define each tag on it's own line please.",
            label_msgid='SCAuditorium_label_allowed_html_tags',
            description_msgid='SCAuditorium_help_allowed_html_tags',
            i18n_domain='SCAuditorium',
        ),
        languageIndependent=True,
    ),
    
    StringField('cover_string',
        default="*!!!*",
        widget=StringWidget(
            label="Cover string",
            description="Enter string which will be used to replace bannded words founded in post's body.",
            label_msgid='SCAuditorium_label_cover_string',
            description_msgid='SCAuditorium_help_cover_string',
            i18n_domain='SCAuditorium',
        ),
        schemata="Masking",
        accessor="coverString",
    ),
    
    DataGridField('banned_words',
        widget=DataGridWidget
        (
            label="Banned words",
            description="Define list of words and it's replacements which will be covered in Post's body. If no replacement is defined for a word, it will be replaced with 'cover string' by default.",
            label_msgid='SCAuditorium_label_banned_words',
            description_msgid='SCAuditorium_help_banned_words',
            i18n_domain='SCAuditorium',
        ),
        languageIndependent=True,
        schemata="Masking",
        accessor="bannedWords",
        columns=('word', 'replacement'),
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class SCAuditorium(BaseBTreeFolder):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseBTreeFolder,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'Auditorium'

    meta_type    = 'SCAuditorium' 
    portal_type  = 'SCAuditorium' 
    allowed_content_types      = ['SCAuditoriumItem'] 
    filter_content_types       = 1
    global_allow               = 1
    allow_discussion           = 0
    #content_icon               = 'SCAuditorium.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "Auditorium"
    typeDescMsgId              = 'description_edit_scauditorium'

    actions =  (


       {'action':      "string:$object_url/scauditorium_view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': (VIEW_PERMISSION,),
        'condition'  : 'python:1'
       },
        

       {'action':      "string:$object_url/scauditorium_moderate",
        'category':    "object",
        'id':          'moderate',
        'name':        'Moderate',
        'permissions': (MODERATE_PERMISSION,),
        'condition'  : 'python:object.isModerated()'
       },
        

    )

    schema = BaseFolderSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declareProtected(EDIT_PERMISSION, 'initializeArchetype')
    def initializeArchetype(self, **kwargs):
        """
        Initialize Auditorium instance.
        """
        portlets = ['here/portlet_sca_pending/macros/portlet',
                    'here/portlet_sca_rejected/macros/portlet']
        source = getattr(self, 'right_slots')
        for portlet in source:
            portlets.append(portlet)

        if self.hasProperty('right_slots'):
            self.manage_changeProperties('right_slots', portlets)            
        else:
            self.manage_addProperty('right_slots', portlets, 'lines', None)



    security.declareProtected(VIEW_PERMISSION, 'getAuditorium')
    def getAuditorium(self):
        """
        Helper method for searching posts.
        """
        
        return self



    security.declareProtected(VIEW_PERMISSION, 'getAuditoriumInfo')
    def getAuditoriumInfo(self):
        """
        Return auditorium informations like last post, number of posts
        and if it is moderated.
        """
        
        pc = getToolByName(self, 'portal_catalog')
        info_data = {}
        isMod = self.isModerated()

        pth = '/'.join(self.getPhysicalPath())
        rstate = 'posted'
        if isMod:
            rstate = 'approved'
            
        posts = pc.searchResults(portal_type = 'SCAuditoriumItem',
                                 path = pth,
                                 sort_on = 'Date',
                                 sort_order = 'reverse',
                                 review_state = rstate);

        info_data['count'] = len(posts)
        info_data['moderated'] = isMod

        if len(posts):
            info_data['last_post'] = posts[:1][0]
        else:
            info_data['last_post'] = None

        return info_data



    security.declareProtected(VIEW_PERMISSION, 'getNiceHTMLTags')
    def getNiceHTMLTags(self):
        """
        Returns allowed HTML tags in nice format.
        """
        tags = self.getAllowed_html_tags()
        
        return ', '.join(['<%s>' % tag for tag in tags])


registerType(SCAuditorium,PROJECTNAME)
# end of class SCAuditorium

##code-section module-footer #fill in your manual code here
##/code-section module-footer



