# File: SCAuditoriumItem.py
"""\
unknown

"""
# Copyright (c) 2005 by SureCase.org
# Generator: ArchGenXML Version 1.4 devel 4 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''SureCase.org <info@surecase.org>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *




from Products.SCAuditorium.config import *
##code-section module-header #fill in your manual code here
from Products.SCAuditorium.lib.HTMLStripper import HTMLStrip
##/code-section module-header

schema= Schema((
    StringField('id',
        widget=StringWidget(
            visible={'edit':'hidden', 'view':'hidden'},
            label='Id',
            label_msgid='SCAuditorium_label_id',
            description='Enter a value for id.',
            description_msgid='SCAuditorium_help_id',
            i18n_domain='SCAuditorium',
        ),
    ),
    
    StringField('title',
        mutator="setTitle",
        widget=StringWidget(
            visible={'edit':'hidden', 'view':'hidden'},
            label='Title',
            label_msgid='SCAuditorium_label_title',
            description='Enter a value for title.',
            description_msgid='SCAuditorium_help_title',
            i18n_domain='SCAuditorium',
        ),
        accessor="Title",
    ),
    
    TextField('body',
        mutator="setBody",
        widget=LimitedTextWidget
        (
            label="Post text",
            description="Enter text for your auditorium post.",
            label_msgid='SCAuditorium_label_body',
            description_msgid='SCAuditorium_help_body',
            i18n_domain='SCAuditorium',
        ),
        required=True,
        searchable=True,
        allowed_content_types=('text/html', 'text/plain'),
        default_output_type='text/html',
        accessor="getBody",
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class SCAuditoriumItem(BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'Post'

    meta_type    = 'SCAuditoriumItem' 
    portal_type  = 'SCAuditoriumItem' 
    allowed_content_types      = [] 
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    content_icon               = 'scauditoriumitem_icon.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    typeDescription            = "Post"
    typeDescMsgId              = 'description_edit_scauditoriumitem'

    actions =  (


       {'action':      "string:$object_url/scauditoriumitem_view",
        'category':    "object",
        'id':          'view',
        'name':        'View',
        'permissions': (VIEW_PERMISSION,),
        'condition'  : 'python:1'
       },
        

    )

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declareProtected("SCAuditorium: Post items", 'setTitle')
    def setTitle(self, value, **kwargs):
        """
        Mutator for field 'title'.
        """

        user_id = self.Creator()
        dt = self.CreationDate()
        title = user_id + ' - ' + dt

        # change Title only if there is no title defined
        if self.getField('title').get(self) == '':
            self.getField('title').set(self, title, **kwargs)



    security.declareProtected(VIEW_PERMISSION, 'getBody')
    def getBody(self, mask=True):
        """
        Accessor for field 'body'.
        """
        body = self.getField('body').get(self)

        if mask:
            # replace banned words.
            ad = self.getAuditorium()
            bwords = ad.bannedWords()
            cover = ad.coverString()
            

            import re
            for w in bwords:
                word = w['word'] or None
                replacement = w['replacement'] or cover
                if word != None:
                    rE = re.compile(r"\b%s\b" % word, re.I)
                    body = rE.sub(replacement, body)

        return body



    security.declareProtected(VIEW_PERMISSION, 'getAuditorium')
    def getAuditorium(self):
        """
        Helper method for searching posts.
        """
        
        obj = self.aq_parent
        while obj.portal_type != 'SCAuditorium':
            obj=obj.aq_parent
        return obj



    security.declareProtected(EDIT_PERMISSION, 'setBody')
    def setBody(self, value, **kwargs):
        """
        Set the Body (remove unallowed HTML tags)
        """
        ad = self.getAuditorium()
        valid_tags = ad.getAllowed_html_tags()
        body = HTMLStrip(value, valid_tags)
        self.getField('body').set(self, body, **kwargs)



    security.declareProtected(VIEW_PERMISSION, 'Description')
    def Description(self):
        """
        Accessor for Description'.
        """
        return self.getBody()



registerType(SCAuditoriumItem,PROJECTNAME)
# end of class SCAuditoriumItem

##code-section module-footer #fill in your manual code here
##/code-section module-footer



